# Damn Vulnerable Web Application - DVWA

[http://www.dvwa.co.uk/](http://www.dvwa.co.uk/) 

**Run in Docker**

 [https://hub.docker.com/r/vulnerables/web-dvwa/](https://hub.docker.com/r/vulnerables/web-dvwa/) , the app will be available at [localhost:80](http://localhost:8080)

```bash
docker run --rm -d -p 80:80 vulnerables/web-dvwa
```

Enter to the web [localhost:80/login](http://localhost:80/login) , user:admin , password:password 

**Run docker container - automatic database creation** 

- [https://github.com/digininja/DVWA/issues/294](https://github.com/digininja/DVWA/issues/294)
- [https://github.com/citizen-stig/dockerdvwa](https://github.com/citizen-stig/dockerdvwa)
- [https://github.com/aracloud/docker-dvwa](https://github.com/aracloud/docker-dvwa)

```bash
docker run -dit -p 8081:80 aracloud/docker-dvwa
```

This container configure the vulnerable site for some type of attacks and create the database

#Integrate different tools

## Build docker images
```bash
   sh build.sh  
```

## Run vulnerable site manually
```bash
   sh dvwa/run_dvwa_instances.sh 8081,8082,8083,8084 8085,8086,8087,8088
```

## Configure
1. For each port in 8085,8086,8087,8088, at the website http://localhost:$PORT configure database.


## Restart apache 
```bash
       sh restart_apache.sh 8081,8082,8083,8084,8085,8086,8087,8088
```


## ZaProxy 
You can find documentation about ZaProxy and examples at [zaproxy/ZaProxy.md](zaproxy/ZaProxy.md). It is a web application scanner which analyzes the security for a certain website and generates a report that identifies each of the vulnerabilities. 

A script has been implemented for the case of DVWA. Indicating the port that DVWA vulnerable site is listening and the security level (low, medium, high, impossible).   
The scripts generates the report for each site in the list, you can invoke it as follows:   

```bash
       sh zaproxy/run_zaproxy.sh 8081:low,8082:medium,8083:high,8084:impossible,8085:low,8086:medium,8087:high,8088:impossible
```

## Threadfix
[ThreadFix](https://threadfix.it/) is an application vulnerability management platform that provides a window into the state of your application security program and helps bridge the communications gap between security and software development teams.
You can importe zaproxy reports at threadfix to better visualization of the report. You can find an example at (zaproxy/images/testreport.html)[zaproxy/images/testreport.html]
```bash 
	docker run -d -p 8089:8443 jmbmxer/threadfix start
```

## Start with docker compose 
The docker compose starts different instances for DVWA with different security level and with or without WAF. 
 
```bash 
 	docker-compose -f docker-compose.yml up -d --force-recreate
```


TODO: configure db for waf instances automatically

